------------------------
-- Implosion Grenade
------------------------

Implosion = {}
Implosion.grenade = {}

Implosion.img = loadgfx("Rainoth/Implosion.bmp")
setmidhandle(Implosion.img)

Implosion.sfx_attack=loadsfx("diaboliclaugh.ogg") -- change this
Implosion.sfx_bounce=loadsfx("bounce.wav")
Implosion.sfx_trigger=loadsfx("Rainoth/implosion.ogg")

Implosion.gfx_wpn1=loadgfx("Rainoth/Implosion_w1.png")
setmidhandle(Implosion.gfx_wpn1)
Implosion.gfx_wpn2=loadgfx("Rainoth/Implosion_w2.png")
setmidhandle(Implosion.gfx_wpn2)
Implosion.gfx_wpn3=loadgfx("Rainoth/Implosion_w3.png") -- frames
setmidhandle(Implosion.gfx_wpn3)
Implosion.gfx_wpn4=loadgfx("Rainoth/Implosion_e1.png")
setmidhandle(Implosion.gfx_wpn4)
Implosion.gfx_wpn5=loadgfx("Rainoth/Implosion_e2.png")
setmidhandle(Implosion.gfx_wpn5)
Implosion.gfx_wpn6=loadgfx("Rainoth/Implosion_e3.png")
setmidhandle(Implosion.gfx_wpn6)

Implosion.id = addweapon("Implosion","Implosion grenade",Implosion.img,0,5,"ballistic")
addweaponinfo("Sucks nearby objects (including players) then completely obliterates terrain around itself")

local numb = 0

function Implosion.draw()
	if weapon_shots <= 0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		drawinhand(Implosion.img,6,0)
	end

	if weapon_charge > 0 and weapon_shots == 0 then
		hudchargebar(weapon_charge,100)
	end

	if weapon_shots == 0 then
		hudcrosshair(4,3)
		hudtimer(3,1,10)
	end
end

function Implosion.attack(attack)
	if (weapon_shots <= 0) then
		if (attack == 1) then
			weapon_charge = weapon_charge + 1
		end
		if (attack == 0 and weapon_charge > 0) or (weapon_charge >= 100) then
			useweapon(0)
			playsound(Implosion.sfx_attack)
			weapon_shots = weapon_shots + 1
			id = createprojectile(Implosion.grenade.id)
			projectiles[id] = {}
			projectiles[id].frame = 0
			-- Ignore collision with current player at beginning
			projectiles[id].ignore = playercurrent()
			-- Set initial position of projectile
			projectiles[id].x = getplayerx(0) + (4*getplayerdirection(0))
			projectiles[id].y = getplayery(0) + 3
			-- Initial collision check (avoid throwing into other objects)
			for i=0,10,1 do
				if collision(col5x5,projectiles[id].x+math.sin(math.rad(getplayerrotation(0)))*i,projectiles[id].y-math.cos(math.rad(getplayerrotation(0)))*i)==1 then
					if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
						if (i==0) then
							projectiles[id].x=getplayerx(0)
							projectiles[id].y=getplayery(0)+3
							break
						else
							projectiles[id].x=getplayerx(0)+(4*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*(i-1)
							projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*(i-1)
							break
						end
					end
				end
			end
			-- Set speed of projectile
			projectiles[id].sx = math.sin(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			projectiles[id].sy = -math.cos(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			-- Set timer
			projectiles[id].timer = weapon_timer*50 + 260
			-- Effects
			recoil(2)
			-- End Turn
			endturn()
		end
	end
end


Implosion.grenade.id=addprojectile("Implosion.grenade")

function Implosion.grenade.draw(id)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	if projectiles[id].frame==0 then
		drawimage(Implosion.img,projectiles[id].x,projectiles[id].y)
	elseif projectiles[id].frame==1 then
		drawimage(Implosion.gfx_wpn1,projectiles[id].x,projectiles[id].y)
	elseif projectiles[id].frame==2 then
		drawimage(Implosion.gfx_wpn2,projectiles[id].x,projectiles[id].y)
	elseif projectiles[id].frame==3 then
		drawimage(Implosion.gfx_wpn3,projectiles[id].x,projectiles[id].y)
	elseif projectiles[id].frame==4 then
		drawimage(Implosion.gfx_wpn4,projectiles[id].x,projectiles[id].y)
	elseif projectiles[id].frame==5 then
		drawimage(Implosion.gfx_wpn5,projectiles[id].x,projectiles[id].y)
	elseif projectiles[id].frame==6 then
		drawimage(Implosion.gfx_wpn6,projectiles[id].x,projectiles[id].y)
	end

	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function Implosion.grenade.update(id)
	-- Gravity influence on speed
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		-- Move X
		projectiles[id].x=projectiles[id].x+msubx
		if collision(col5x5,projectiles[id].x,projectiles[id].y)==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
				if (math.abs(projectiles[id].sx)>0.5) then playsound(Implosion.sfx_bounce) end
				projectiles[id].x=projectiles[id].x-msubx
				projectiles[id].sx=-projectiles[id].sx*0.3
				msubx=-msubx*0.3
			end
		else
			projectiles[id].ignore=0
		end
		-- Move Y
		projectiles[id].y=projectiles[id].y+msuby
		if collision(col5x5,projectiles[id].x,projectiles[id].y)==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
				if (math.abs(projectiles[id].sy)>0.5) then playsound(Implosion.sfx_bounce) end
				projectiles[id].y=projectiles[id].y-msuby
				projectiles[id].sy=-projectiles[id].sy*0.3
				msuby=-msuby*0.3
				projectiles[id].sx=projectiles[id].sx*0.9
				msubx=msubx*0.9
			end
		else
			projectiles[id].ignore=0
		end		
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			break
		end
	end
	-- Timer -> Explode
	projectiles[id].timer = projectiles[id].timer-1		
	if projectiles[id].timer<=260 then -- timer ends, begin implosion
			-- check distance to targets
		local players=playertable(0,0)
		local x = projectiles[id].x
		local y = projectiles[id].y
		for i=1,#players do
			if math.sqrt((x-getplayerx(players[i]))^2+(y-getplayery(players[i]))^2)<=30 then
				playerposition(players[i],x,-9999999)
				playerposition(players[i],x,y)
			elseif math.sqrt((x-getplayerx(players[i]))^2+(y-getplayery(players[i]))^2)<=100 then
				playerpush(players[i],0,0,1,0)
				playerforceframe(players[i],4)
				suck_a=getplayerx(players[i])-x
				suck_b=getplayery(players[i])-y
				suck_sqrt=math.sqrt(suck_a*suck_a+suck_b*suck_b)
				suck_x=getplayerx(players[i])-suck_a/(suck_sqrt^2)*200
				suck_y=getplayery(players[i])-suck_b/(suck_sqrt^2)*200
				playerposition(players[i],suck_x,suck_y)
			end
		end
		for pi=1,#projectiles do
			if projectiles[pi].x~=nil and projectiles[pi].y~=nil then
				if math.sqrt((x-projectiles[pi].x)^2+(y-projectiles[pi].y)^2)<=30 then
					if pi ~= id then
						freeprojectile(pi)
					end
				elseif math.sqrt((x-projectiles[pi].x)^2+(y-projectiles[pi].y)^2)<=150 then
					psuck_a=projectiles[pi].x-x
					psuck_b=projectiles[pi].y-y
					psuck_sqrt=math.sqrt(psuck_a*psuck_a+psuck_b*psuck_b)
					psuck_x=projectiles[pi].x-psuck_a/(psuck_sqrt^2)*200
					psuck_y=projectiles[pi].y-psuck_b/(psuck_sqrt^2)*200
					projectiles[pi].x=psuck_x
					projectiles[pi].y=psuck_y
				end
			end
		end
		local objectz=objecttable()
		for oi=1,#objectz do
			if math.sqrt((x-getobjectx(objectz[oi]))^2+(y-getobjecty(objectz[oi]))^2)<=30 then
				if objectz[oi]~=id then
					removeobject(objectz[oi])
				end
			elseif math.sqrt((x-getobjectx(objectz[oi]))^2+(y-getobjecty(objectz[oi]))^2)<=150 then
				if objectz[oi]~=id then
					osuck_a=getobjectx(objectz[oi])-x
					osuck_b=getobjecty(objectz[oi])-y
					osuck_sqrt=math.sqrt(osuck_a*osuck_a+osuck_b*osuck_b)
					osuck_x=getobjectx(objectz[oi])-osuck_a/(osuck_sqrt^2)*200
					osuck_y=getobjecty(objectz[oi])-osuck_b/(osuck_sqrt^2)*200
					objectposition(objectz[oi],osuck_x,osuck_y)
				end
			end
		end
		if projectiles[id].timer == 260 then
			playsound(Implosion.sfx_trigger)
			projectiles[id].frame = 1
		end
		numb = numb + 1
		if numb >= 3 then
			if projectiles[id].frame == 3 then
				projectiles[id].frame = 1
			else
				projectiles[id].frame = projectiles[id].frame + 1
			end
			numb = 0
		end
	end
	if projectiles[id].timer <= 85 and projectiles[id].timer > 82 then
		projectiles[id].frame = 4
	elseif projectiles[id].timer <= 82 and projectiles[id].timer > 79 then
		projectiles[id].frame = 5
	elseif projectiles[id].timer <= 79 then
		projectiles[id].frame = 6
		if projectiles[id].timer < 75 then
			freeprojectile(id)
			arealdamage(projectiles[id].x,projectiles[id].y,50,99999)
			terrainexplosion(projectiles[id].x,projectiles[id].y,80,2)
		end
	end
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
end

function Implosion.grenade.damage(id,damage)
end